Index: palm/trunk/SOURCE/data_output_2d.f90
===================================================================
--- palm/trunk/SOURCE/data_output_2d.f90	(revision 4901)
+++ palm/trunk/SOURCE/data_output_2d.f90	(revision 1)
@@ -442,62 +287,190 @@
                 level_z(nzb+1) = zu(nzb+1)
 
-             CASE ( 'ghf*_xy' )        ! 2d-array
-                IF ( av == 0 )  THEN
-                   DO  m = 1, surf_lsm_h(0)%ns
-                      i                   = surf_lsm_h(0)%i(m)
-                      j                   = surf_lsm_h(0)%j(m)
-                      local_pf(i,j,nzb+1) = surf_lsm_h(0)%ghf(m)
+             CASE ( 'p_xy', 'p_xz', 'p_yz' )
+                IF ( av == 0 )  THEN
+                   to_be_resorted => p
+                ELSE
+                   to_be_resorted => p_av
+                ENDIF
+                IF ( mode == 'xy' )  level_z = zu
+
+             CASE ( 'pc_xy', 'pc_xz', 'pc_yz' )  ! particle concentration
+                IF ( av == 0 )  THEN
+                   tend = prt_count
+                   CALL exchange_horiz( tend, 0, 0 )
+                   DO  i = nxl-1, nxr+1
+                      DO  j = nys-1, nyn+1
+                         DO  k = nzb, nzt+1
+                            local_pf(i,j,k) = tend(k,j,i)
+                         ENDDO
+                      ENDDO
                    ENDDO
-                   DO  m = 1, surf_usm_h(0)%ns
-                      i                   = surf_usm_h(0)%i(m)
-                      j                   = surf_usm_h(0)%j(m)
-                      local_pf(i,j,nzb+1) = surf_usm_h(0)%frac(m,ind_veg_wall)  *                     &
-                                            surf_usm_h(0)%wghf_eb(m)        +                         &
-                                            surf_usm_h(0)%frac(m,ind_pav_green) *                     &
-                                            surf_usm_h(0)%wghf_eb_green(m)  +                         &
-                                            surf_usm_h(0)%frac(m,ind_wat_win)   *                     &
-                                            surf_usm_h(0)%wghf_eb_window(m)
-                   ENDDO
-                ELSE
-                   IF ( .NOT. ALLOCATED( ghf_av ) )  THEN
-                      ALLOCATE( ghf_av(nysg:nyng,nxlg:nxrg) )
-                      ghf_av = REAL( fill_value, KIND = wp )
-                   ENDIF
+                   resorted = .TRUE.
+                ELSE
+                   CALL exchange_horiz( pc_av, 0, 0 )
+                   to_be_resorted => pc_av
+                ENDIF
+
+             CASE ( 'pr_xy', 'pr_xz', 'pr_yz' )  ! mean particle radius
+                IF ( av == 0 )  THEN
                    DO  i = nxl, nxr
                       DO  j = nys, nyn
-                         local_pf(i,j,nzb+1) = ghf_av(j,i)
+                         DO  k = nzb, nzt+1
+                            psi = prt_start_index(k,j,i)
+                            s_r3 = 0.0
+                            s_r4 = 0.0
+                            DO  n = psi, psi+prt_count(k,j,i)-1
+                               s_r3 = s_r3 + particles(n)%radius**3
+                               s_r4 = s_r4 + particles(n)%radius**4
+                            ENDDO
+                            IF ( s_r3 /= 0.0 )  THEN
+                               mean_r = s_r4 / s_r3
+                            ELSE
+                               mean_r = 0.0
+                            ENDIF
+                            tend(k,j,i) = mean_r
+                         ENDDO
                       ENDDO
                    ENDDO
-                ENDIF
-
+                   CALL exchange_horiz( tend, 0, 0 )
+                   DO  i = nxl-1, nxr+1
+                      DO  j = nys-1, nyn+1
+                         DO  k = nzb, nzt+1
+                            local_pf(i,j,k) = tend(k,j,i)
+                         ENDDO
+                      ENDDO
+                   ENDDO
+                   resorted = .TRUE.
+                ELSE
+                   CALL exchange_horiz( pr_av, 0, 0 )
+                   to_be_resorted => pr_av
+                ENDIF
+
+             CASE ( 'pt_xy', 'pt_xz', 'pt_yz' )
+                IF ( av == 0 )  THEN
+                   IF ( .NOT. cloud_physics ) THEN
+                      to_be_resorted => pt
+                   ELSE
+                      DO  i = nxl-1, nxr+1
+                         DO  j = nys-1, nyn+1
+                            DO  k = nzb, nzt+1
+                               local_pf(i,j,k) = pt(k,j,i) + l_d_cp *    &
+                                                             pt_d_t(k) * &
+                                                             ql(k,j,i)
+                            ENDDO
+                         ENDDO
+                      ENDDO
+                      resorted = .TRUE.
+                   ENDIF
+                ELSE
+                   to_be_resorted => pt_av
+                ENDIF
+                IF ( mode == 'xy' )  level_z = zu
+
+             CASE ( 'q_xy', 'q_xz', 'q_yz' )
+                IF ( av == 0 )  THEN
+                   to_be_resorted => q
+                ELSE
+                   to_be_resorted => q_av
+                ENDIF
+                IF ( mode == 'xy' )  level_z = zu
+
+             CASE ( 'ql_xy', 'ql_xz', 'ql_yz' )
+                IF ( av == 0 )  THEN
+                   to_be_resorted => ql
+                ELSE
+                   to_be_resorted => ql_av
+                ENDIF
+                IF ( mode == 'xy' )  level_z = zu
+
+             CASE ( 'ql_c_xy', 'ql_c_xz', 'ql_c_yz' )
+                IF ( av == 0 )  THEN
+                   to_be_resorted => ql_c
+                ELSE
+                   to_be_resorted => ql_c_av
+                ENDIF
+                IF ( mode == 'xy' )  level_z = zu
+
+             CASE ( 'ql_v_xy', 'ql_v_xz', 'ql_v_yz' )
+                IF ( av == 0 )  THEN
+                   to_be_resorted => ql_v
+                ELSE
+                   to_be_resorted => ql_v_av
+                ENDIF
+                IF ( mode == 'xy' )  level_z = zu
+
+             CASE ( 'ql_vp_xy', 'ql_vp_xz', 'ql_vp_yz' )
+                IF ( av == 0 )  THEN
+                   to_be_resorted => ql_vp
+                ELSE
+                   to_be_resorted => ql_vp_av
+                ENDIF
+                IF ( mode == 'xy' )  level_z = zu
+
+             CASE ( 'qv_xy', 'qv_xz', 'qv_yz' )
+                IF ( av == 0 )  THEN
+                   DO  i = nxl-1, nxr+1
+                      DO  j = nys-1, nyn+1
+                         DO  k = nzb, nzt+1
+                            local_pf(i,j,k) = q(k,j,i) - ql(k,j,i)
+                         ENDDO
+                      ENDDO
+                   ENDDO
+                   resorted = .TRUE.
+                ELSE
+                   to_be_resorted => qv_av
+                ENDIF
+                IF ( mode == 'xy' )  level_z = zu
+
+             CASE ( 's_xy', 's_xz', 's_yz' )
+                IF ( av == 0 )  THEN
+                   to_be_resorted => q
+                ELSE
+                   to_be_resorted => q_av
+                ENDIF
+
+             CASE ( 't*_xy' )        ! 2d-array
+                IF ( av == 0 )  THEN
+                   DO  i = nxl-1, nxr+1
+                      DO  j = nys-1, nyn+1
+                         local_pf(i,j,nzb+1) = ts(j,i)
+                      ENDDO
+                   ENDDO
+                ELSE
+                   DO  i = nxl-1, nxr+1
+                      DO  j = nys-1, nyn+1
+                         local_pf(i,j,nzb+1) = ts_av(j,i)
+                      ENDDO
+                   ENDDO
+                ENDIF
                 resorted = .TRUE.
                 two_d = .TRUE.
                 level_z(nzb+1) = zu(nzb+1)
 
-             CASE ( 'ol*_xy' )        ! 2d-array
-                IF ( av == 0 )  THEN
-                   DO  m = 1, surf_def_h(0)%ns
-                      i = surf_def_h(0)%i(m)
-                      j = surf_def_h(0)%j(m)
-                      local_pf(i,j,nzb+1) = surf_def_h(0)%ol(m)
+             CASE ( 'u_xy', 'u_xz', 'u_yz' )
+                IF ( av == 0 )  THEN
+                   to_be_resorted => u
+                ELSE
+                   to_be_resorted => u_av
+                ENDIF
+                IF ( mode == 'xy' )  level_z = zu
+!
+!--             Substitute the values generated by "mirror" boundary condition
+!--             at the bottom boundary by the real surface values.
+                IF ( do2d(av,if) == 'u_xz'  .OR.  do2d(av,if) == 'u_yz' )  THEN
+                   IF ( ibc_uv_b == 0 )  local_pf(:,:,nzb) = 0.0
+                ENDIF
+
+             CASE ( 'u*_xy' )        ! 2d-array
+                IF ( av == 0 )  THEN
+                   DO  i = nxl-1, nxr+1
+                      DO  j = nys-1, nyn+1
+                         local_pf(i,j,nzb+1) = us(j,i)
+                      ENDDO
                    ENDDO
-                   DO  m = 1, surf_lsm_h(0)%ns
-                      i = surf_lsm_h(0)%i(m)
-                      j = surf_lsm_h(0)%j(m)
-                      local_pf(i,j,nzb+1) = surf_lsm_h(0)%ol(m)
-                   ENDDO
-                   DO  m = 1, surf_usm_h(0)%ns
-                      i = surf_usm_h(0)%i(m)
-                      j = surf_usm_h(0)%j(m)
-                      local_pf(i,j,nzb+1) = surf_usm_h(0)%ol(m)
-                   ENDDO
-                ELSE
-                   IF ( .NOT. ALLOCATED( ol_av ) )  THEN
-                      ALLOCATE( ol_av(nysg:nyng,nxlg:nxrg) )
-                      ol_av = REAL( fill_value, KIND = wp )
-                   ENDIF
-                   DO  i = nxl, nxr
-                      DO  j = nys, nyn
-                         local_pf(i,j,nzb+1) = ol_av(j,i)
+                ELSE
+                   DO  i = nxl-1, nxr+1
+                      DO  j = nys-1, nyn+1
+                         local_pf(i,j,nzb+1) = us_av(j,i)
                       ENDDO
                    ENDDO
